package de.fitko.fitconnect.api.config;

import lombok.Data;

@Data
public class ApplicationConfig {
    
    private String httpProxyHost = "";
    private Integer httpProxyPort = 0;
    private Integer requestTimeoutInSeconds;

    private Sender sender;
    private Subscriber subscriber;

    private Environments environments;
    private UsedEnvironment usedEnvironment;

    private ResourcePaths resourcePaths;

    public Environment getActiveEnvironment() {
        switch (usedEnvironment) {
            case PROD:
                return environments.getProd();
            case TEST:
                return environments.getTest();
            default:
                return environments.getDev();
        }
    }

    public String getOAuthTokenEndpoint(){
        return getActiveEnvironment().getAuthBaseUrl() + resourcePaths.getAuthTokenPath();
    }

    public String getSubmissionsEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getSubmissionsPath();
    }

    public String getSubmissionEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getSubmissionPath();
    }

    public String getAttachmentEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getSubmissionAttachmentPath();
    }

    public String getEventLogEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getEventLogPath();
    }

    public String destinationEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getDestinationPath();
    }

    public String destinationKeyEndpoint() {
        return getActiveEnvironment().getSubmissionBaseUrl() + resourcePaths.getDestinationKeyPath();
    }
}

