package de.fitko.fitconnect.api.domain.model.jwk;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

public enum AlgEnum {

    PS512("PS512"),

    RSA_OAEP_256("RSA-OAEP-256");

    private final String value;

    AlgEnum(final String value) {
        this.value = value;
    }

    @JsonValue
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }

    @JsonCreator
    public static AlgEnum fromValue(final String value) {
        for (final AlgEnum algEnum : AlgEnum.values()) {
            if (algEnum.value.equals(value)) {
                return algEnum;
            }
        }
        throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
}
