package de.fitko.fitconnect.api.domain.model.jwk;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

public enum EEnum {

    AQAB("AQAB");

    private final String value;

    EEnum(final String value) {
        this.value = value;
    }

    @JsonValue
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }

    @JsonCreator
    public static EEnum fromValue(final String value) {
        for (final EEnum eEnum : EEnum.values()) {
            if (eEnum.value.equals(value)) {
                return eEnum;
            }
        }
        throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
}
