package de.fitko.fitconnect.api.domain.model.jwk;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

public enum KeyOpsEnum {

    VERIFY("verify"),

    WRAPKEY("wrapKey");

    private final String value;

    KeyOpsEnum(final String value) {
        this.value = value;
    }

    @JsonValue
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }

    @JsonCreator
    public static KeyOpsEnum fromValue(final String value) {
        for (final KeyOpsEnum keyOpsEnum : KeyOpsEnum.values()) {
            if (keyOpsEnum.value.equals(value)) {
                return keyOpsEnum;
            }
        }
        throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
}
