package de.fitko.fitconnect.api.domain.model.jwk;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

public enum KtyEnum {

    RSA("RSA");

    private final String value;

    KtyEnum(final String value) {
        this.value = value;
    }

    @JsonValue
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }

    @JsonCreator
    public static KtyEnum fromValue(final String value) {
        for (final KtyEnum ktyEnum : KtyEnum.values()) {
            if (ktyEnum.value.equals(value)) {
                return ktyEnum;
            }
        }
        throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
}
