package de.fitko.fitconnect.api.domain.model.metadata.attachment;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import de.fitko.fitconnect.api.domain.model.metadata.attachment.signature.Hash__1;
import de.fitko.fitconnect.api.domain.model.metadata.attachment.signature.Signature__1;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;
import java.util.UUID;

@Data
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Attachment {

    @JsonProperty("hash")
    private Hash__1 hash;

    @JsonProperty("signature")
    private Signature__1 signature;

    @JsonProperty("purpose")
    private Purpose purpose;

    @JsonProperty("filename")
    private String filename;

    @JsonProperty("description")
    private String description;

    @JsonProperty("mimeType")
    private String mimeType;

    @JsonProperty("attachmentId")
    private UUID attachmentId;

    @JsonIgnore
    private Map<String, Object> additionalProperties;
}


