package de.fitko.fitconnect.api.domain.model.metadata.attachment;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.HashMap;
import java.util.Map;

public enum Purpose {

    FORM("form"),
    ATTACHMENT("attachment"),
    REPORT("report");
    private final String value;
    private final static Map<String, Purpose> CONSTANTS = new HashMap<>();

    static {
        for (Purpose c : values()) {
            CONSTANTS.put(c.value, c);
        }
    }

    Purpose(String value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return this.value;
    }

    @JsonValue
    public String value() {
        return this.value;
    }

    @JsonCreator
    public static Purpose fromValue(String value) {
        Purpose constant = CONSTANTS.get(value);
        if (constant == null) {
            throw new IllegalArgumentException(value);
        } else {
            return constant;
        }
    }
}
