package de.fitko.fitconnect.client.cmd.commands;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import de.fitko.fitconnect.client.cmd.util.UUIDConverter;
import de.fitko.fitconnect.client.cmd.util.UUIDValidator;

import java.util.UUID;

import static de.fitko.fitconnect.client.cmd.commands.ListOneSubmissionCommand.GET_CMD_NAME;


@Parameters(
        commandNames = {GET_CMD_NAME},
        commandDescription = "Fetches one submission by id",
        separators = "="
)
public
class ListOneSubmissionCommand {

    public static final String GET_CMD_NAME = "get";

    @Parameter(names = { "--submissionId" }, description = "Unique submission identifier in UUID format", converter = UUIDConverter.class, validateWith = UUIDValidator.class, arity = 1, required = true)
    public
    UUID submissionId;

    @Parameter(names = { "--target" }, description = "Target folder where attachments and data is written to", arity = 1)
    public
    String targetFolder;
}
