package de.fitko.fitconnect.core.http;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpRequest;
import org.springframework.http.client.ClientHttpRequestExecution;
import org.springframework.http.client.ClientHttpRequestInterceptor;
import org.springframework.http.client.ClientHttpResponse;

import java.io.IOException;

/**
 * Intercepts HTTP calls and logs the request url
 */
public class ApiRequestInterceptor implements ClientHttpRequestInterceptor {

    private static final Logger logger = LoggerFactory.getLogger(ApiRequestInterceptor.class);

    @Override
    public ClientHttpResponse intercept(final HttpRequest req, final byte[] reqBody,
                                        final ClientHttpRequestExecution ex) throws IOException {
        logger.info("{}", req.getURI());
        return ex.execute(req, reqBody);
    }
}